var hearttoheart = "";
var h2hsource = "Char";
var areaname = "";

function HeartToHeart_main(contentText) {
	PlaceResponceContent(contentText);
}

function HeartToHeart_Area(contentText) {
	h2hsource = "Area";
}

function HeartToHeart_Character(contentText) {
	h2hsource = "Char";
	var query = "Select Name From Character ORDER BY CharacterID";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);
			sb.append("<li><input type='button' class='character' style=\"background-image : url('img/small/");
			sb.append(row.Name);
			sb.append(".png');\" onclick=\"ClickHeartCharacter('");
			sb.append(row.Name);
			sb.append("');\"><\/li>");
		}
		sb.append("</ul>");
		contentText = contentText.replace("#CHARLIST#", sb.toString());
		sb.clear();
		PlaceResponceContent(contentText);
	});
}

function ClickHeartCharacter(character) {
	charactername = character;
	load("hearttoheart_characterlist.xml");
}

function HeartToHeart_CharacterList(contentText) {
	var query = "Select * From HeartToHeart WHERE Character1 ='" + charactername + "' OR Character2 ='" + charactername + "' ORDER BY Affinity ";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		contentText = contentText.replace("#CHARNAME#", charactername);
		var sb = new StringBuilder();
		sb.append("<ul>");
		var arr = {};

		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);
			var theOther = row.Character1;
			if(theOther == charactername) {
				theOther = row.Character2;
			}

			if(!arr["" + theOther]) {
				arr["" + theOther] = new Array();
			}
			sb2 = new StringBuilder();
			sb2.append("<li><div class='h2hrow' onclick=\"HeartToHeart_Click('");
			sb2.append(row.Name.replace(/\'/gi,"\\'"));
			sb2.append("');\"><div class='affinityName affinity");
			sb2.append(theOther);
			sb2.append("'></div>");
			sb2.append(row.Name);
			sb2.append("<div class='affinity");
			sb2.append(row.Affinity);
			sb2.append("'></div></div></li>");

			arr[""+theOther][i] = sb2.toString();
		}
		for(var i in arr) {
			for(var j in arr[i]) {
				sb.append(arr[i][j]);
			}
		}
		sb.append("</ul>");
		contentText = contentText.replace("#H2HLIST#", sb.toString());
		sb.clear();
		PlaceResponceContent(contentText);
	});
}

function HeartToHeart_Click(h2hname) {
	hearttoheart = h2hname;
	load("hearttoheart_detail.xml");
}

function HeartToHeart_Detail(contentText) {
	switch(h2hsource) {
		case"Char":
			contentText = contentText.replace("#BACKTRACE#", "<a href=\"#\" onClick=\"ClickHeartCharacter('" + charactername + "');\">" + charactername + "</a>");
			break;
		case"Available":
			contentText = contentText.replace("#BACKTRACE#", "<a href=\"#\" onClick=\"load('hearttoheart_available.xml');\">Available</a>");
			break;
		case"Area":
			contentText = contentText.replace("#BACKTRACE#", "<a href=\"#\" onClick=\"load('hearttoheart_arealist.xml');\">"+areaname+"</a>");
			
			
			break;
	}
	var query = "SELECT *,H.Affinity as h2hAffinity,A.Affinity as charAffinity FROM HeartToHeart as H left join Affinity as A on A.Character1 = H.Character1 WHERE A.Character2 = H.Character2 AND H.Name = \"" + hearttoheart + "\" LIMIT 1;";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var row = result.rows.item(0);
		contentText = contentText.replace("#H2HNAME#", row.Name);
		var sb = new StringBuilder();
		sb.append("<input type='button' class='character_noclick' style=\"background-image:url('img/small/");
		sb.append(row.Character1);
		sb.append(".png');\">");
		contentText = contentText.replace("#CHARACTER1#", sb.toString());
		sb.clear();

		sb.append("<input type='button' class='character_noclick' style=\"background-image:url('img/small/");
		sb.append(row.Character2);
		sb.append(".png');\">");
		contentText = contentText.replace("#CHARACTER2#", sb.toString());
		sb.clear();
		contentText = contentText.replace("#AREA#", row.Area);
		contentText = contentText.replace("#LOCATION#", row.Location);

		var best1 = row.Best.substr(0, 1);
		var best2 = row.Best.substr(2, 1);
		if(best1 == "1") {
			contentText = contentText.replace("#FIRST#", "The first answer.");
		} else {
			contentText = contentText.replace("#FIRST#", "The second answer.");
		}
		if(best2 == "1") {
			contentText = contentText.replace("#SECOND#", "The first answer.");
		} else {
			contentText = contentText.replace("#SECOND#", "The second answer.");
		}
		var status = row.Status;

		switch(row.Status) {
			case 2:
				contentText = contentText.replace("#STATUS#", "Completed");
				contentText = contentText.replace("#STATUSBUTTON#", "");
				break;
			case 0:
			case 1:
				if(row.h2hAffinity <= row.charAffinity) {
					contentText = contentText.replace("#STATUS#", "Available");
					contentText = contentText.replace("#STATUSBUTTON#", "<div class=\"menubutton\" onclick=\"HeartToHeart_Completed_Click();\" >Completed</div>");
				} else {
					contentText = contentText.replace("#STATUS#", "Not yet available");
					contentText = contentText.replace("#STATUSBUTTON#", "<div class=\"menubutton\" onclick=\"HeartToHeart_Completed_Click();\" >Completed</div>");
				}
				break;
		}
		PlaceResponceContent(contentText);
	});
}

function HeartToHeart_Completed_Click() {
	navigator.notification.confirm('Completed heart to heart?', HeartToHeart_Completed, hearttoheart, 'Completed,Cancel');
}

function HeartToHeart_Completed(button) {
	if(button == 1) {
		var query = "UPDATE HeartToHeart SET Status=2 WHERE Name = '" + hearttoheart + "';";
		DB.GetInstance().ExecuteQuery(query, function(result) {
		});
		load("hearttoheart_detail.xml");
	}
}

function HeartToHeart_Config(contentText) {
	var query = "Select Name From Character ORDER BY CharacterID";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);
			sb.append("<li><input type='button' class='character' style=\"background-image : url('img/small/");
			sb.append(row.Name);
			sb.append(".png');\" onclick=\"ClickHeartToHeartConfigCharacter('");
			sb.append(row.Name);
			sb.append("');\"><\/li>");
		}
		sb.append("</ul>");
		contentText = contentText.replace("#CHARLIST#", sb.toString());
		sb.clear();
		PlaceResponceContent(contentText);
	});
}

function ClickHeartToHeartConfigCharacter(character) {
	charactername = character;
	load("hearttoheart_config_character.xml");
}

function HeartToHeart_Config_Character(contentText) {
	var query = "Select * From Character as C LEFT OUTER JOIN Affinity as A on C.Name = A.Character2 WHERE C.Name != '" + charactername + "' AND A.Character1 = '" + charactername + "' ORDER BY C.CharacterID ;";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		contentText = contentText.replace("#CHARNAME#", charactername);
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);
			var affinity = row.Affinity;
			sb.append("<li><div class='h2hrow' onclick=\"AffinityClick('");
			sb.append(row.Name.replace(/\'/gi,"\\'"));
			sb.append("');\"><div class='affinityName affinity");
			sb.append(row.Name);
			sb.append("'></div>");
			sb.append(row.Name);
			sb.append("<div id='affinityName");
			sb.append(row.Name);
			sb.append("' class='affinity");
			sb.append(affinity);
			sb.append("' num='");
			sb.append(affinity);
			sb.append("' ></div></div></li>");
		}
		sb.append("</ul>");
		contentText = contentText.replace("#CHARLIST#", sb.toString());
		sb.clear();
		PlaceResponceContent(contentText);
	});
}

function AffinityClick(secondchar) {
	var elAffinity = $("#affinityName" + secondchar);
	var iAffinity = parseInt(elAffinity.attr("num"));

	elAffinity.removeClass("affinity" + iAffinity);
	iAffinity += 1;
	if(iAffinity == 6) {
		iAffinity = 1;
	}
	elAffinity.attr("num", iAffinity);
	elAffinity.addClass("affinity" + iAffinity);
}

function SaveAffinityAndReturn() {
	var query = "Select Name From Character WHERE Name !='" + charactername + "' ORDER BY CharacterID";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var queries = Array();
		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);
			var iAffinity = $("#affinityName" + row.Name).attr("num");
			queries.push("UPDATE Affinity SET Affinity = '" + iAffinity + "' WHERE Character1='" + charactername + "' AND Character2='" + row.Name + "';");
			queries.push("UPDATE Affinity SET Affinity = '" + iAffinity + "' WHERE Character1='" + row.Name + "' AND Character2='" + charactername + "';");
		}
		DB.GetInstance().ExecuteQueryArray(queries);
		load("hearttoheart_config.xml");
	});
}

function HeartToHeart_Available(contentText) {
	h2hsource = "Available";
	var query = "SELECT DISTINCT H.Name,H.Character1,H.Character2,H.Name,H.Affinity FROM HeartToHeart as H WHERE  H.Affinity <= (SELECT Affinity FROM Affinity  as A WHERE A.Character1 = H.Character1 AND A.Character2 = H.Character2 LIMIT 1) AND STATUS = 0;";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			var row = result.rows.item(i);

			sb.append("<li><div class='h2hrow' onclick=\"HeartToHeart_Click('");
			sb.append(row.Name.replace(/\'/gi,"\\'"));
			sb.append("');\"><div class='affinityName affinity");
			sb.append(row.Character1);
			sb.append("'></div>");
			sb.append(row.Name);
			sb.append("<div class='affinityNameRight affinity");
			sb.append(row.Character2);
			sb.append("'></div></div></li>");
		}

		sb.append("</ul>");
		contentText = contentText.replace("#H2HLIST#", sb.toString());
		sb.clear();
		PlaceResponceContent(contentText);
	});
}

function HeartToHeart_Area(contentText) {
	h2hsource = "Area";
	var query = "SELECT DISTINCT Area FROM HeartToHeart";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			sb.append("<li><div class='h2hrow' onclick=\"HeartToHeart_Area_Click('");
			sb.append(result.rows.item(i).Area.replace(/\'/gi,"\\'"));
			sb.append("')\"><b>");
			sb.append(result.rows.item(i).Area);
			sb.append("</b></div></li>");
		}
		sb.append("</ul>");
		contentText = contentText.replace("#AREALIST#", sb.toString());
		PlaceResponceContent(contentText);
	});
}

function HeartToHeart_Area_Click(name) {
	areaname = name;
	load("hearttoheart_arealist.xml");
}

function HeartToHeart_AreaList(contentText) {
	contentText = contentText.replace("#AREA#", areaname);
	var query = "SELECT * FROM HeartToHeart WHERE Area = \""+areaname+"\" ORDER BY Location;";
	DB.GetInstance().ExecuteQuery(query, function(result) {
		var sb = new StringBuilder();
		sb.append("<ul>");
		for(var i = 0; i < result.rows.length; i++) {
			var row=result.rows.item(i);
			sb.append("<li><div class='h2hrow' onclick=\"HeartToHeart_Click('");
			sb.append(row.Name.replace(/\'/gi,"\\'"));
			sb.append("');\"><div class='affinityName affinity");
			sb.append(row.Character1);
			sb.append("'></div>");
			sb.append(row.Name);
			sb.append("<div class='affinityNameRight affinity");
			sb.append(row.Character2);
			sb.append("'></div></div></li>");
		}
		sb.append("</ul>");
		contentText = contentText.replace("#H2HLIST#", sb.toString());
		
		PlaceResponceContent(contentText);
	});
}